Subject: Re: bug#69689: 30.0.50; cannot native compile with -flto in native-comp-compiler-options

From: StrawberryTea <[email-masked]>
Date: Sun, 17 Mar 2024 13:17:43 -0500

Andrea Corallo <[email-masked]> writes:

> Paul Eggert <[email-masked]> writes:
>
>> On 3/11/24 06:38, Eli Zaretskii wrote:
>>
>>> configure.ac says "experimental", so I guess it's not yet reliable
>>> enough?
>>
>> It was added by Dmitry Antipov in 2012. I never use it, and didn't
>> even recall it until I looked at configure.ac recently.
>>
>> I've not have good luck with -lto elsewhere. It can make linking slow
>> and it tends to expose compiler bugs. Unless someone's using it
>> regularly I would consider it experimental.
>
> Also as a note.
>
> I doubt using native compilation with LTO could bring measurable
> advantages.
>
> All the Emacs C primitives we call from elns have a function pointer
> indirection as they can be redefined, so GCC can't inline them.  Few
> support functions are called directly but I would be surprised of any
> measurable effect there.
>
> Best Regards
>
>   Andrea

I see. I am going to report this to the GCC bug tracker to try and get
it fixed. I would like to use LTO with native compilation, even if it
would not bring any measurable advantages. And I feel there has to be
some GCC person that knows how to fix this.